import 'dart:convert';
import 'package:http/http.dart' as http;
import 'package:native_progress_hud/native_progress_hud.dart';

class ApiService {
//  var baseUrl = "https://gateway-test.eneoapps.com:5000";//gateway test
  var baseUrl = "http://192.168.100.25:5000"; //local

  /// [context] : the actual context of the app
  /// [transactionId] : the amount of the bill
  /// [transactionAmount] : the amount you want to pay
  /// [transactionCallBackUrl] : your callBack url
  InitiatePayment(
      {context,
        String transactionId,
        String transactionAmount,
        String transactionCallBackUrl}) async {
    try {
//      progressHub("Loading", context);
      var jsonResponse;
      var response = await http.post(
//          "${baseUrl}/gateway/initialize", In test
          "${baseUrl}/payments/gateway/initialize",
          body: jsonEncode({
            "bills": [
              {"amount": transactionAmount, "bill_ref": "330904644"}
            ],
            "transaction_id": transactionId,
            "total_amount": transactionAmount,
            "return_url": "https://eneocameroon.cm/index.php/en/"
          }),
          headers: {
            'Content-Type': 'application/json',
            'Authorization': 'Basic ${getEncode()}',
            'X-API-KEY': '7c4a8d09ca3762af61e59520943dc26494f8941b',
          });

      if (response.statusCode == 201) {
        jsonResponse = json.decode(response.body);
        if (jsonResponse != null) {
          print(" 201 response /initiate : ${json.decode(response.body)}");
//          return json.decode(response.body);
          print(
              "This is transaction ID : ${json.decode(response.body)['t_id']}");
          return getAllProviders(
            context: context,
            transactionId: json.decode(response.body)['t_id'],
            transactionAmount: json.decode(response.body)['t_sum'],
            transactionCallBackUrl: json.decode(response.body)['t_url'],
          );
        }
      } else {
        jsonResponse = json.decode(response.body);
        if (jsonResponse != null) {
          print(" Else response /initiate : ${json.decode(response.body)}");
          closeDialog(context);
//          return json.decode(response.body);
        }
      }
    } catch (e) {
      print(" 201 error /initiate : ${e}");
      closeDialog(context);
    } finally {
      closeDialog(context);
    }
  }

  /// [context] : the actual context of the app
  /// [transactionId] : the amount of the bill
  /// [transactionAmount] : the amount you want to pay
  /// [transactionCallBackUrl] : your callBack url
  getAllProviders(
      {context,
        String transactionId,
        String transactionAmount,
        String transactionCallBackUrl}) async {
    try {
      var jsonResponse;
//      progressHub("Loading", context);
      var response = await http.get(
//          "${baseUrl}/gateway/gateways?t_id=${transactionId}&t_sum=${transactionAmount}&t_url='${transactionCallBackUrl}'", //In Test
          "${baseUrl}/payments/gateway/gateways?t_id=${transactionId}&t_sum=${transactionAmount}&t_url='${transactionCallBackUrl}'",
          headers: {
            'Content-Type': 'application/json',
            'Authorization': 'Basic ${getEncode()}',
            'X-API-KEY': '7c4a8d09ca3762af61e59520943dc26494f8941b',
          });
      if (response.statusCode == 200) {
        jsonResponse = json.decode(response.body);
        if (jsonResponse != null) {
          print(" 200 response /providers : ${json.decode(response.body)}");
          return json.decode(response.body)['data'];
        }
      } else {
        jsonResponse = json.decode(response.body);
        if (jsonResponse != null) {
          print(" Else response /providers : ${json.decode(response.body)}");
          closeDialog(context);
          return [];
        }
      }
    } catch (e) {
      print(" 200 error /providers : ${e}");
      closeDialog(context);
    } finally {
      closeDialog(context);
    }
  }

  /// [context] : the actual context of the app
  /// [transactionId] : the amount of the bill
  /// [transactionAmount] : the amount you want to pay
  /// [transactionCallBackUrl] : your callBack url
  /// [provider_short_tag] : the tag of the provider
  /// [phoneNumber] : the phone number of the client
  /// [userName] : the user name of the client
  makePayment(
      {context,
        String transactionId,
        String transactionAmount,
        String transactionCallBackUrl,
        String provider_short_tag,
        String phoneNumber,
        String userName}) async {
    var response;
    try {
      var jsonResponse;
      if (provider_short_tag == 'mtnmomo' || provider_short_tag == 'orange') {
        response = await http.post("${baseUrl}/payments/gateway/makepayment",
            body: jsonEncode({
              'gateway': provider_short_tag,
              'amount': transactionAmount,
              'transaction_id': transactionId,
              'return_url': transactionCallBackUrl,
//            'transactions': this.utility.getTransactions(),
//            'name': username,
              'phone_number': phoneNumber,
            }),
            headers: {
              'Content-Type': 'application/json',
              'Authorization': 'Basic ${getEncode()}',
              'X-API-KEY': '7c4a8d09ca3762af61e59520943dc26494f8941b',
            });
      } else if (provider_short_tag == 'eu') {
        response = await http.post("${baseUrl}/payments/gateway/makepayment",
            body: jsonEncode({
              'gateway': provider_short_tag,
              'amount': transactionAmount,
              'transaction_id': transactionId,
              'return_url': transactionCallBackUrl,
//            'transactions': this.utility.getTransactions(),
              'name': userName,
              'phone_number': phoneNumber,
            }),
            headers: {
              'Content-Type': 'application/json',
              'Authorization': 'Basic ${getEncode()}',
              'X-API-KEY': '7c4a8d09ca3762af61e59520943dc26494f8941b',
            });
      }

      if (response.statusCode == 200) {
        jsonResponse = json.decode(response.body);
        if (jsonResponse != null) {
          print(" 200 response /makePayment : ${json.decode(response.body)}");
          return json.decode(response.body)['data'];
        }
      } else {
        jsonResponse = json.decode(response.body);
        if (jsonResponse != null) {
          print(" Else response /makePayment : ${json.decode(response.body)}");
          closeDialog(context);
          return [];
        }
      }
    } catch (e) {
      print(" 200 error /makePayment : ${e}");
      closeDialog(context);
    } finally {
      closeDialog(context);
    }
  }

  //Able to check the status of the payment of payment to Ecobank
  checkEcobankStatusPayment() {}

  String getEncode() {
    String credentials = "myeasylight-payments:easylight-payments@2020*";
    Codec<String, String> stringToBase64 = utf8.fuse(base64);
    String encoded = stringToBase64.encode(credentials);
    return encoded;
  }

  progressHub(msg, context) {
    NativeProgressHud.showWaitingWithText(msg);
  }

  closeDialog(context) {
    NativeProgressHud.hideWaiting();
  }
}
